import enum
import sys
import json
import re
import pdb
from collections import defaultdict


sql_keywords = [
    "[PAD]", "[CLS]", "[SEP]", "select", "distinct", "from", "where",
    "join", "on", "as", "group", "order", "by", "asc", "desc", "having", "limit",
    "intersect", "except", "union", "count", "sum", "min", "max", "avg", "(", ")",
    ",", "<", "<=", "==", ">=", ">", "!=", "between", "in", "and" ,
    "or", "not", "like", "+", "-", "*", "/", "0", "1", "2",
    "3", "4", "5", "6", "7", "8", "9", "10", "time_now", "\"", "value",
    "select2", "row", "cluster", "是", "否", "@", "all", "inf", "[unused00]", "[unused01]",
    "[unused02]", "[unused03]"
]

dusql = json.load(open(sys.argv[1]))


single = 0
s_grpby = 0
s_ordby = 0
s_limit = 0
s_gol = 0
s_having = 0
s_complex = 0
multi = 0

sel = 0
se2 = 0
iue = 0
row = 0
err_sel = 0
err_se2 = 0
err_iue = 0
err_row = 0
err = 0
amb = 0
cnt = dusql['count']
cnt = 0

err_map = {"select": [], "select2":[], "iue":[], "row": []}

err_map = defaultdict(list)
all_map = defaultdict(list)
amb_map = defaultdict(list)

err_map1 = defaultdict(list)

err_plm = 0

exs = []

pmc = 0
gmc = 0
exc = 0

mc_unordered = 0
err_mc_unordered = 0

result = defaultdict(int)
rall = defaultdict(int)

def has_mathcol(s):
    if '[unused91]' in s:
        return True
    if 'row' in s:
        return False
    st = s.split()
    for op in ["+", "-", "*", "/"]:
        try:
            idx = st.index(op)
            if st[idx-1] != st[idx+1] and st[idx-1] != "(":
                return True
        except:
            continue
    return False


def parse_sql(s):
    s = [str(i) for i in s]
    intent = s[0]
    w_idx = sql_keywords.index('where')
    c_idx = sql_keywords.index('cluster')
    comma = sql_keywords.index(',')

    s1 = ' '.join(s[1:])
    s1 = s1.replace(str(w_idx), str(comma))
    s1 = s1.replace(str(c_idx), str(comma))
    s1 = [t for t in s1.strip().split(str(comma)) if t.strip()]
    s1.sort()
    return [intent] + s1


def parse_aql(q):
    remain = q
    select = ""
    where = ""
    cluster = ""
    if 'where' in remain:
        select, remain = remain.split("where", 1)
        select = select.split("select", 1)[1].strip()
    
    if 'cluster' in remain:
        where, cluster = remain.split("cluster", 1)
        where = where.strip()
        cluster = cluster.strip()
    
    scols = [select.split()]


def iscorrect(p, g):
    for i, t in enumerate(g):
        if not t or t == 1:
            continue
        if p[i] != t:
            return False
    return True

def iscorrect(p, g):
    l = 0
    r = 0
    lk = 0
    lc = 0
    lv = 0
    rk = 0
    rc = 0
    rv = 0
    for i, t in enumerate(g):
        if not t or t == -1:
            continue
        if p[i] == t:
            if t < 45:
                rk += 1
            if t in (1,2):
                pass
                # rk += 1
            elif t in (3,4):
                rc += 1
            elif t in (5,6,7):
                rv += 1
            r += 1
        if t < 45:
            lk += 1
        if t in (1,2):
            pass
        elif t in (3,4):
            lc += 1
        elif t in (5,6,7):
            lv += 1
        l += 1
    if l == 0:
        r = 1
        l = 1
    if lk == 0:
        rk = 1
        lk = 1
    if lc == 0:
        rc = 1
        lc = 1
    if lv == 0:
        rv = 1
        lv = 1
    return r / l, rk / lk, rc / lc, rv / lv

recall = 0
r_k = 0
r_c = 0
r_v = 0

for i, ex in enumerate(dusql['result']):
    q = ex['q']
    intent = 'select'
    all_map[intent].append(ex)
    cnt += 1

    if len(ex['pred']) <= 5:
        rall["<=5"] += 1
    elif len(ex['pred']) <= 10:
        rall["<=10"] += 1
    elif len(ex['pred']) <= 15:
        rall["<=15"] += 1
    elif len(ex['pred']) <= 20:
        rall["<=20"] += 1
    elif len(ex['pred']) <= 25:
        rall["<=25"] += 1
    elif len(ex['pred']) <= 30:
        rall["<=30"] += 1
    else:
        rall[">30"] += 1

    try:
        c_base = ex['c_base']
        gtc = [tuple(tc) for tc in ex['gold_columnt'] if tc[0] - c_base >= 3 ]
        ptc = [tuple(tc) for tc in ex['pred_columnt'] ]
    except:
        pass

    if ex['pred'] == ex['gold'] and ptc == gtc:
        if len(ex['pred']) <= 5:
            result["<=5"] += 1
        elif len(ex['pred']) <= 10:
            result["<=10"] += 1
        elif len(ex['pred']) <= 15:
            result["<=15"] += 1
        elif len(ex['pred']) <= 20:
            result["<=20"] += 1
        elif len(ex['pred']) <= 25:
            result["<=25"] += 1
        elif len(ex['pred']) <= 30:
            result["<=30"] += 1
        else:
            result[">30"] += 1
    else:
        if len(sys.argv) >= 3 and gtc != ptc:
            print(ex['nt'])
            print(ex['q_tokenize'])
            print(ex['sql'])
            print(ex['pred_sql'])
            print(ex['amap'])
            print(ex['pred_amap'])
            print(ex['gold_columnt'])
            print(ex['pred_columnt'])
            print()

        err += 1
        err_map[intent].append(ex)
    
    try:
        a_, k_, c_, v_ = iscorrect(ex['pred_align'], ex['gold_align'])
        recall += a_
        r_k += k_
        r_c += c_
        r_v += v_
    except:
        pass

print("all", err, cnt, pmc, 1 - err / (cnt), pmc/cnt, 'recall:', recall / cnt, r_k/cnt, r_c/cnt, r_v/cnt)
